Codeforces Round 923 (Div. 3)F

2024-02-14 23:52
文章标签 codeforces round div 923

本文主要是介绍Codeforces Round 923 (Div. 3)F,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

CF1927F. Microcycle

题意:给定一个n个点,m条边的无向图,图不一定连通,要求找到图中的一个环,该环上的最小边权比图中所有环的边权要小,输出这个最小边权,所在的环上的节点数量以及按顺序输出所在的环上的所有节点。
思路:因为要求最小边权,我们可以想到要用kruskal算法,首先将所有边权从大到小的顺序排序,然后按边权从大到小建立图,用并查集来判断环,因为是从大到小遍历边权,因此如果第一次遍历到两个节点在一个集合中,这条边就是所在环的最小边权,然后就可以找到最小的环的边权,同时记录下来最小边权的两个节点,再跑一边dfs找到换上的节点即可
代码如下

#include<bits/stdc++.h>using namespace std;const int N = 2e5+10;typedef pair<int,int>pii;struct Node
{int u,v,w;const bool operator<(Node t)const{return w>t.w;}
}edge[N];
int f[N];int find(int x)
{if(x!=f[x])f[x]=find(f[x]);return f[x];
}
int main()
{ios::sync_with_stdio(false);cin.tie(0);cout.tie(0);int T;cin>>T;while(T--){int n,m;cin>>n>>m;for(int i=1;i<=n;i++)f[i]=i;vector<vector<pii>>g(n+1);for(int i=0;i<m;i++){int u,v,w;cin>>u>>v>>w;edge[i]={u,v,w};}sort(edge,edge+m);//重载了<,将边权从大到小排序int U=-1,V=-1,W=-1;//记录最小边权的两个节点,以及最小边权的权值for(int i=0;i<m;i++){int a=edge[i].u,b=edge[i].v,c=edge[i].w;g[a].push_back({b,c});g[b].push_back({a,c});//建图int fa=find(a),fb=find(b);if(fa==fb)U=a,V=b,W=c;//更新环的最小边权else f[fa]=fb;//合并集合}vector<bool>st(n+1,0);vector<int>path;auto dfs = [&](auto&& dfs,int u)->bool{if(u==V)return true;//因为使用vector存图,所以当环中有三个节点及以上时不用担心第一个就会遍历到点V//如果是用链表存图的话这里就要换一种写法了st[u]=1;//标记被访问过for(auto it:g[u]){if(it.second<W||st[it.first])continue;path.push_back(it.first);if(dfs(dfs,it.first))return true;path.pop_back();}return false;};path.push_back(U);dfs(dfs,U);cout<<W<<" "<<path.size()<<"\n";for(auto x:path)cout<<x<<" ";cout<<"\n";// for(int i=0;i<m;i++)cout<<" "<<edge[i].u<<" "<<edge[i].v<<" "<<edge[i].w<<"\n";}return 0;
}
···

这篇关于Codeforces Round 923 (Div. 3)F的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/709925

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

CSS实现DIV三角形

本文内容收集来自网络 #triangle-up {width: 0;height: 0;border-left: 50px solid transparent;border-right: 50px solid transparent;border-bottom: 100px solid red;} #triangle-down {width: 0;height: 0;bor

创建一个大的DIV,里面的包含两个DIV是可以自由移动

创建一个大的DIV,里面的包含两个DIV是可以自由移动 <body>         <div style="position: relative; background:#DDF8CF;line-height: 50px"> <div style="text-align: center; width: 100%;padding-top: 0px;"><h3>定&nbsp;位&nbsp;

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

CF#271 (Div. 2) D.(dp)

D. Flowers time limit per test 1.5 seconds memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/474/problem/D We s

CF #278 (Div. 2) B.(暴力枚举+推导公式+数学构造)

B. Candy Boxes time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/488/problem/B There